/*
 *  File name:  aes_main.c
 *  Date first: 12/05/2017
 *  Date last:  12/17/2017
 *
 *  Description: Test and example program for STM8 AES 128-bit library.
 *
 *  Author:     Richard Hodges
 *
 ******************************************************************************
 *
 *  Copyright (C) 2017 Richard Hodges.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * If you wish to license this code under different terms, please
 * contact the author: richard@hodges.org
 *
 ******************************************************************************
 *
 *  Includes
 */

#include "aes_stm8.h"

/******************************************************************************
 *
 *  Set up context, encrypt and decrypt one block
 */

int main(void)
{
    AES_CTX	 ctx;
    BYTE	 key[16];
    BYTE	 block[16];

    /* shove your AES key in here */

    key[ 0] = 0x2b;		/* this is the FIPS-197 test key */
    key[ 1] = 0x7e;
    key[ 2] = 0x15;
    key[ 3] = 0x16;
    key[ 4] = 0x28;
    key[ 5] = 0xae;
    key[ 6] = 0xd2;
    key[ 7] = 0xa6;
    key[ 8] = 0xab;
    key[ 9] = 0xf7;
    key[10] = 0x15;
    key[11] = 0x88;
    key[12] = 0x09;
    key[13] = 0xcf;
    key[14] = 0x4f;
    key[15] = 0x3c;

    block[ 0] = 0x32;
    block[ 1] = 0x43;
    block[ 2] = 0xf6;
    block[ 3] = 0xa8;
    block[ 4] = 0x88;
    block[ 5] = 0x5a;
    block[ 6] = 0x30;
    block[ 7] = 0x8d;
    block[ 8] = 0x31;
    block[ 9] = 0x31;
    block[10] = 0x98;
    block[11] = 0xa2;
    block[12] = 0xe0;
    block[13] = 0x37;
    block[14] = 0x07;
    block[15] = 0x34;

    aes_new_key(&ctx, key);
    aes_encrypt(&ctx, block);
    aes_decrypt(&ctx, block);

    return 0;
}
